Loading...
Searching...
No Matches
Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node Class Reference

Leaf basis node that encapsulates a local finite-element given from the LFEPreBasisMixin of type LFE. More...

`#include <dune/functions/functionspacebases/lfeprebasismixin.hh>`

Inheritance diagram for Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node:

## Public Types

using | size_type = std::size_t
using | Element = typename GV::template Codim<0>::Entity
using | FiniteElement = LFE

## Public Member Functions

| Node (const LFE &lfe)
| Constructor; stores a pointer to the passed local finite-element lfe.
const Element & | element () const
| Return current element; might raise an error if unbound.
const FiniteElement & | finiteElement () const
| Return the LocalFiniteElement for the element we are bound to; might raise an error if unbound.
void | bind (const Element &e)
| Bind to element. Stores a pointer to the passed element reference.
size_type | localIndex (size_type i) const
size_type | size () const
| Obtain the number of basis function in the local node.
bool | empty () const
| Check if the node is empty.
size_type | treeIndex () const

## Static Public Member Functions

static constexpr auto | degree ()

## Static Public Attributes

static const bool | isLeaf = true
static const bool | isPower = false
static const bool | isComposite = false

## Protected Member Functions

size_type | offset () const
void | setOffset (const size_type offset)
void | setSize (const size_type size)
void | setTreeIndex (size_type treeIndex)

## Protected Attributes

const FiniteElement * | lfe_
const Element * | element_

## Detailed Description

template<class GV, class LFE>
class Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node

Leaf basis node that encapsulates a local finite-element given from the LFEPreBasisMixin of type LFE.

The Node implements the LEafBasisNode interface. Its stores a pointer to the local finite-element given by the LFEPreBasisMixin. Thus, the lifetime of the pre-basis must be greater than the lifetime of this node.

## Member Typedef Documentation

## Element

template<class GV, class LFE>

using Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::Element = typename GV::template Codim<0>::Entity

## FiniteElement

template<class GV, class LFE>

using Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::FiniteElement = LFE

## size_type

template<class GV, class LFE>

using Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::size_type = std::size_t

## Constructor & Destructor Documentation

## Node()

template<class GV, class LFE>

Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::Node | ( | const LFE & | lfe | ) |

inline explicit

Constructor; stores a pointer to the passed local finite-element lfe.

## Member Function Documentation

## bind()

template<class GV, class LFE>

void Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::bind | ( | const Element & | e | ) |

inline

Bind to element. Stores a pointer to the passed element reference.

## degree()

constexpr auto Dune::Functions::LeafBasisNode::degree | ( |  | ) |

inline static constexpr inherited

## element()

template<class GV, class LFE>

const Element & Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::element | ( |  | ) | const

inline

Return current element; might raise an error if unbound.

## empty()

bool Dune::Functions::BasisNodeMixin::empty | ( |  | ) | const

inline inherited

Check if the node is empty.

This is equivalent to size()==0. Notice that it is undefined behaviour to access the element() and finiteElement() methods of the node if it is empty, i.e., if its size is zero.

## finiteElement()

template<class GV, class LFE>

const FiniteElement & Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::finiteElement | ( |  | ) | const

inline

Return the LocalFiniteElement for the element we are bound to; might raise an error if unbound.

The LocalFiniteElement implements the corresponding interfaces of the dune-localfunctions module

## localIndex()

size_type Dune::Functions::BasisNodeMixin::localIndex | ( | size_type | i | ) | const

inline inherited

## offset()

size_type Dune::Functions::BasisNodeMixin::offset | ( |  | ) | const

inline protected inherited

## setOffset()

void Dune::Functions::BasisNodeMixin::setOffset | ( | const size_type | offset | ) |

inline protected inherited

## setSize()

void Dune::Functions::BasisNodeMixin::setSize | ( | const size_type | size | ) |

inline protected inherited

## setTreeIndex()

void Dune::Functions::BasisNodeMixin::setTreeIndex | ( | size_type | treeIndex | ) |

inline protected inherited

## size()

size_type Dune::Functions::BasisNodeMixin::size | ( |  | ) | const

inline inherited

Obtain the number of basis function in the local node.

Notice that it is undefined behaviour to access the element() and finiteElement() methods of the node if it is empty, i.e., if its size is zero.

## treeIndex()

size_type Dune::Functions::BasisNodeMixin::treeIndex | ( |  | ) | const

inline inherited

## Member Data Documentation

## element_

template<class GV, class LFE>

const Element* Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::element_

protected

## isComposite

const bool Dune::Functions::LeafBasisNode::isComposite = false

static inherited

## isLeaf

const bool Dune::Functions::LeafBasisNode::isLeaf = true

static inherited

## isPower

const bool Dune::Functions::LeafBasisNode::isPower = false

static inherited

## lfe_

template<class GV, class LFE>

const FiniteElement* Dune::Functions::LFEPreBasisMixin< GV, LFE >::Node::lfe_

protected

The documentation for this class was generated from the following file:

- lfeprebasismixin.hh